config/routes.rb
Rails.application.routes.draw do

  root to: "static#home"
  
  concern :paginatable do
    get '(page/:page)', :action => :index, :on => :collection
  end
  
  concern :searchable do
    get 'search/:search', :action => :search, :on => :collection, as: 'search_result'
    post 'search/', :action => :search, :on => :collection, :as => 'search'
  end
  
  concern :search_paginatable do
    get 'search/:search/(page/:page)', :action => :search, :on => :collection
  end
  
  devise_for :users, path: 'account'
  get '/' => 'static#home', :as => 'home'
  get '/team' => 'static#team', :as => 'team'
  get '/deine-chance' => 'static#youtube', :as => 'deine_chance'
  get '/youtube' => 'static#youtube', :as => 'youtube'
  get '/bewerbung' => 'static#application', :as => 'application'
  get '/team/history' => 'static#team_history', :as => 'team_history'
  get '/maps' => 'static#maps', :as => 'maps'
  get '/premium' => 'static#premium', :as => 'premium'
  get '/statistik' => 'static#statistic', :as => 'statistic'
  get '/kontakt' => 'static#contact', :as => 'contact'
  get '/impressum' => 'static#imprint', :as => 'imprint'
  get '/agb' => 'static#tos', :as => 'tos'
  
  resources :chatlogs, only: [:show]

  resources :users, path: 'players', except: [:edit, :update], param: :name, :concerns => [:searchable] do
    get 'statistic'
    get 'youtube'
  end
  
  resources :users, path: 'players/uuid/', only: [:edit]
  resources :users, path: 'players', only: [:update]
  
  get '/players/uuid/:id/' => 'users#show'
  get '/players/uuid/:id/statistic' => 'users#statistic'
  get '/players/uuid/:id/youtube' => 'users#youtube'
  
  get 'sitemap.xml' => 'sitemap#index'
  
  namespace :dashboard, layout: 'dashboard' do
    get '/' => 'users#online', :as => 'dashboard'
    resources :chatlogs, :concerns => [:searchable, :search_paginatable, :paginatable]
    resources :users, path: 'players', :concerns => [:searchable, :search_paginatable, :paginatable] do
      get 'online', :on => :collection
      get 'chatlogs'
    end
  end
  
end

app/controllers/dashboard/chatlogs_controller.rb
class Dashboard::ChatlogsController < ApplicationController
  before_action :authenticate_user!
  before_filter :verify_access
  load_and_authorize_resource
  
  def index
		@chatlogs = Chatlog.order_by(:created => 'desc').page params[:page]
  end
  
  def search
    if params[:search].empty?
      redirect_to chatlogs_path()
    elsif params[:search] && request.post?
      redirect_to search_result_dashboard_chatlogs_path(params[:search])
    elsif params[:search] && request.get?
      @chatlogs = Chatlog.where({_id: /.*#{params[:search]}.*/i }).order_by(:created => 'desc').page params[:page]
      if @chatlogs.count == 1
        redirect_to dashboard_chatlog_path(@chatlogs.first.id)
      else
        render 'index'
      end
		end
	end
  
	def show
    @chatlog = Chatlog.find_by(_id: params[:id])
    if @chatlog.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Chatlog nicht gefunden" })
    end
	end
	
	private
  def verify_access
    redirect_back(fallback_location: home_path) unless can? :access, :dashboard
  end
end

app/controllers/dashboard/users_controller.rb
class Dashboard::UsersController < ApplicationController
  before_action :authenticate_user!
  before_filter :verify_access
  load_and_authorize_resource
  
  def index
    @users = User.order_by(:name => 'asc').page params[:page]
  end
  
  def online
    @users = User.where({:online => true }).order_by(:name => 'asc').page params[:page]
    
    user_ips = []
    @users.each{|player| user_ips << player.ip}

    @second_account_ip_groups = User.where({:ip.in => user_ips}).order_by(:ip => 'asc', :lastSeen => 'desc').group_by{|player| player.ip}
  end
  
  def search
    if params[:search].empty? || (params[:search].to_s.length < 3 && !(can? :index, User))
      redirect_back(fallback_location: home_path, :flash => { :error => "Suchbegriff zu kurz" })
    elsif params[:search] && request.post?
      redirect_to search_result_dashboard_users_path(params[:search])
    elsif params[:search] && request.get?
      @users = User.where({
        "$or" => [
          {_id: "#{params[:search]}" },
          {name: /.*#{params[:search]}.*/i }
        ]
      }).order_by(:name => 'asc').page params[:page]
      if @users.count == 1
        redirect_to dashboard_user_path(@users.first)
      else
        render 'index'
      end
		end
	end
  	
	def show
      @user = User.find_by(id: params[:id])
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
	end
	
	def chatlogs
    @user = User.find_by(id: params[:user_id])
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
    @chatlogs = Chatlog.where({"messages.user_id": @user._id }).order_by(:created => 'desc').page params[:page]
	end
	
	def edit
    if params.has_key?(:id)
      @user = User.find_by(id: params[:id])
    elsif params.has_key?(:name)
      @user = User.find_by(name: params[:name])
    end
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
	end
	
	def update
	
		if params.has_key?(:id)
      @user = User.find_by(id: params[:id])
    elsif params.has_key?(:name)
      @user = User.find_by(name: params[:name])
    end
    if @user.nil?
      redirect_back(fallback_location: home_path, :flash => { :error => "Spieler nicht gefunden" })
    end
		if @user.update_without_password(user_params)
			redirect_to user_path(@user.name), :flash => { :success => "Spieler gespeichert" }
		else
      flash[:error] = ["Fehler beim Speichern"]
      @user.errors.full_messages.each do |msg|
        flash[:error] << msg
      end
			render 'edit'
		end
	end
	
	private
		def user_params
			params.require(:user).permit(:youtube_id)
		end
		
  def verify_access
    redirect_back(fallback_location: home_path) unless can? :access, :dashboard
  end
end

app/views/shared/dashboard/_footer.html.slim
footer
  .fixed-action-btn[style="bottom: 45px; right: 24px;"]
    a.button-collapse.btn-floating.btn-large.bwnet.hide-on-large-and-up.white-text.mobile-nav[href="#" data-activates="nav-dashboard"]
      = content_tag(:i, 'menu', class: 'material-icons')

app/views/shared/dashboard/_navigation.html.slim
ul#nav-dashboard.side-nav.fixed
  li
    .userView.center-align
      .bwnet.background
      h3.white-text
        | Dashboard
  - if content_for?(:searchbar)
      = yield(:searchbar)
      li
        .divider[style="margin: 20px 0;"]
  li
    = link_to(home_path()) do
      = content_tag(:i, 'home', class: 'material-icons')
      | Zur Website
  - if (can? :index, Chatlog) || (can? :index, User)
    li
      .divider
    li
      a.subheader
        | Intern
  - if can? :index, Chatlog
     li class=('active' if (params[:controller] == "dashboard/chatlogs"))
        = link_to(dashboard_chatlogs_path()) do
          = content_tag(:i, 'attach_file', class: 'material-icons')
          = Chatlog.model_name.human(count: 2)
  - if can? :index, User
    li
      ul.collapsible.collapsible-accordion
        li
          a.collapsible-header class=('active' if (params[:controller] == "dashboard/users"))
            = content_tag(:i, 'people', class: 'material-icons')
            = User.model_name.human
          .collapsible-body
            ul
              li class=('active' if (params[:controller] == "dashboard/users" && params[:action] == "online"))
                = link_to(online_dashboard_users_path()) do
                  = content_tag(:i, 'people', class: 'material-icons')
                  => User.model_name.human
                  | online
              li class=('active' if (params[:controller] == "dashboard/users" && (params[:action] == "index" || params[:action] == "search")))
                = link_to(dashboard_users_path()) do
                  = content_tag(:i, 'people', class: 'material-icons')
                  | Alle 
                  = User.model_name.human
  - if content_for?(:actions)
    .divider[style="margin: 20px 0;"]
    = yield(:actions)
  li
    .divider[style="margin: 20px 0;"]
  li
    = link_to(destroy_user_session_path, :method => :delete, class: "red white-text") do
      = content_tag(:i, 'clear', class: 'material-icons white-text')
      | Abmelden